#include <cstdio>
#include <cstring>
#include <cctype>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 256;
const char ANS[] = "WAKJSD";
const int dx[] = {1, 0, -1, 0};
const int dy[] = {0, 1, 0, -1};

int n, m, mat[MAXN][MAXN], component, tot[MAXN * MAXN];

inline bool valid(int x, int y) {
	return x >= 0 && x < n && y >= 0 && y < m;
}

void dfs(int x, int y, int col, int idx) {
	mat[x][y] = idx;
	for (int d = 0; d < 4; d++) {
		int xx = x + dx[d], yy = y + dy[d];
		if (valid(xx, yy) && mat[xx][yy] == col) {
			dfs(xx, yy, col, idx);
		}
		if (valid(xx, yy) && mat[xx][yy] != idx) {
			component = mat[xx][yy];
		}
	}
}

int main() {
	int test = 0;
	while (scanf("%d%d", &n, &m) != EOF && n != 0) {
		memset(mat, 0, sizeof(mat));
		for (int i = 1; i <= n; i++) {
			char buffer[65536];
			scanf("%s", buffer);
			for (int j = 0; j < m; j++) {
				int num = isdigit(buffer[j]) ? buffer[j] - '0' : buffer[j] - 'a' + 10;
				for (int k = 0; k < 4; k++) {
					if (num & (1 << k)) {
						mat[i][((j << 2) | (3 - k)) + 1] = 1;
					}
				}
			}
		}
		n += 2;
		m = (m << 2) + 2;
		int idx = 1;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (mat[i][j] == 1) {
					dfs(i, j, 1, ++idx);
				}
			}
		}
		
		for (int i = 2; i <= idx; i++) {
			tot[i] = 0;
		}

		dfs(0, 0, 0, -1);

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (mat[i][j] == 0) {
					component = -1;
					dfs(i, j, 0, -1);
					tot[component]++;
				}
			}
		}

		vector<char> ans;
		for (int i = 2; i <= idx; i++) {
			ans.push_back(ANS[tot[i]]);
		}
		sort(ans.begin(), ans.end());
		printf("Case %d: ", ++test);
		for (int i = 0; i < (int)ans.size(); i++) {
			putchar(ans[i]);
		}
		puts("");
	}
	return 0;
}
